routes/web.php
<?php

use App\Http\Controllers\CustomerController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\SettingController;
use App\Http\Controllers\OrderController;
use App\Http\Controllers\CartController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//   return view('welcome');
// });

Auth::routes();

Route::middleware(['auth'])->group(function () {
  Route::get('/',  [HomeController::class, 'index'])->name('dashboard');
  Route::get('/dashboard', [HomeController::class, 'index'])->name('dashboard');
  Route::resource('products', ProductController::class);
  Route::get('setting', [SettingController::class, 'index'])->name('setting.index');
  Route::post('setting', [SettingController::class, 'store'])->name('setting.store');
  Route::resource('customers', CustomerController::class);
  Route::resource('orders', OrderController::class);

  Route::get('/cart', [CartController::class, 'index'])->name('cart.index');
  // Route::get('/cart/{id}', [CartController::class, 'store'])->name('cart.store');
  Route::post('/cart', [CartController::class, 'store'])->name('cart.store');
  Route::get('/cart/{id}', [CartController::class, 'addToCart'])->name('add_to_cart');
  Route::patch('/cart/update', [CartController::class, 'updateCart'])->name('update_cart');
  Route::post('/cart/change-qty', [CartController::class, 'changeQty'])->name('changeQty');
  Route::delete('/cart/delete', [CartController::class, 'delete'])->name('cart.delete');
  Route::delete('/cart/empty', [CartController::class, 'empty']);
});

app/Models/product.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class product extends Model
{
  use HasFactory;

  protected $table = 'products';

  protected $fillable = [
    'name',
    'description',
    'image',
    'barcode',
    'price',
    'quantity',
    'status'
  ];
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Models\product;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;


class ProductController extends Controller
{
  /**
   * Display a listing of the resource.
   *
   * @return \Illuminate\Http\Response
   */
  public function index()
  {
    if (request()->wantsJson()) {
      return response(
        product::all()
      );
    }
    $products = product::latest()->paginate(10);
    return view('pages.product.index')->with('products', $products);
  }

  /**
   * Show the form for creating a new resource.
   *
   * @return \Illuminate\Http\Response
   */
  public function create()
  {
    return view('pages.product.create');
  }

  /**
   * Store a newly created resource in storage.
   *
   * @param  \Illuminate\Http\Request  $request
   * @return \Illuminate\Http\Response
   */
  public function store(Request $request)
  {
    $validatedData = $request->validate([
      'name'  => 'required|max:20|unique:products',
      'description'  => 'required|max:20',
      'image'   => 'nullable|mimes:jpeg,png,jpg|max:100',
      'barcode'   => 'nullable|string|max:50|unique:products',
      'price'   => 'required|regex:/^\d+(\.\d{1,2})?$/',
      'quantity'   => 'required|integer',
      'status' => 'required|boolean'
    ]);

    $filePath = '';

    if ($request->file()) {
      $fileName = $request->name . '-' . time() . '.' . $request->image->extension();
      $filePath = $request->file('image')->storeAs('products', $fileName, 'public');

      $validatedData['image'] = $filePath;
    }

    $product = product::create($validatedData);

    if (!$product) {
      return redirect()->back()->with('error', 'Maaf, kamu belum gagal menambahkan product.');
    }
    return redirect()->route('products.index')->with('success', 'Berhasil, kamu berhasil menambahkan product.');
  }

  /**
   * Display the specified resource.
   *
   * @param  int  $id
   * @return \Illuminate\Http\Response
   */
  public function show($id)
  {
    $products = product::find($id);

    return view('pages.product.show', ['product' => $products]);
  }

  /**
   * Show the form for editing the specified resource.
   *
   * @param  int  $id
   * @return \Illuminate\Http\Response
   */
  public function edit($id)
  {
    $products = product::find($id);

    return view('pages.product.edit', ['product' => $products]);
  }

  /**
   * Update the specified resource in storage.
   *
   * @param  \Illuminate\Http\Request  $request
   * @param  int  $id
   * @return \Illuminate\Http\Response
   */
  public function update(Request $request, $id)
  {
    $validatedData = $request->validate([
      'name'  => 'required|max:20',
      'description'  => 'required|max:20',
      'image'   => 'nullable|mimes:jpeg,png,jpg|max:100',
      'barcode'   => 'nullable|string|max:50|unique:products',
      'price'   => 'required|regex:/^\d+(\.\d{1,2})?$/',
      'quantity'   => 'required|integer',
      'status' => 'required|boolean'
    ]);

    // jika type file dengan value 'nama_colum', maka
    if ($request->file('image')) {
      // jika gambar lama ada, maka kita akan Delete
      if ($request->oldImage) {
        Storage::delete($request->oldImage);
      }
      # jika ada gambar maka kita Upload
      $fileName = $request->name . '-' . time() . '.' . $request->image->extension();
      $filePath = $request->file('image')->storeAs('products', $fileName, 'public');

      $validatedData['image'] = $filePath;
    }

    product::findOrFail($id)->update($validatedData);

    return redirect()->route('products.index')->with('success', 'Success, data product berhasil di edit.');
  }

  /**
   * Remove the specified resource from storage.
   *
   * @param  int  $id
   * @return \Illuminate\Http\Response
   */
  public function destroy($id)
  {
    $product = product::FindOrFail($id);

    $filePath = $product->image;
    Storage::disk('public')->delete($filePath);

    $product->delete();
    return response()->json(['success' => 'Berhasil Dihapus!']);
  }
}

resources/views/pages/product/create.blade.php
@extends('adminlte.master')

@section('title', 'Halaman Product')

@section('content')
<div class="card">
  <div class="card-header">
    <h3 class="card-title">Tambah Product</h3>
  </div>
  <!-- /.card-header -->
  <div class="card-body">
    <form action="{{ route('products.store') }}" method="POST" enctype="multipart/form-data">
      @csrf

      <div class="form-group">
        <label for="name">Nama Product</label>
        <input type="text" name="name" class="form-control @error('name') is-invalid @enderror" id="name"
          placeholder="Nama Product" value="{{ old('name') }}">
        @error('name')
        <span class="invalid-feedback" role="alert">
          <strong>{{ $message }}</strong>
        </span>
        @enderror
      </div>

      <div class="form-group">
        <label for="description">Deskripsi Product</label>
        <input type="text" name="description" class="form-control @error('description') is-invalid @enderror"
          id="description" placeholder="Deskripsi Product" value="{{ old('description') }}">
        @error('description')
        <span class="invalid-feedback" role="alert">
          <strong>{{ $message }}</strong>
        </span>
        @enderror
      </div>

      <div class="form-group">
        <label for="image">Gambar Product</label>
        <div class="custom-file">
          <input type="file" class="custom-file-input" name="image" id="image">
          <label class="custom-file-label" for="image">Choose file</label>
        </div>
        @error('image')
        <span class="invalid-feedback" role="alert">
          <strong>{{ $message }}</strong>
        </span>
        @enderror
      </div>

      <div class="form-group">
        <label for="barcode">Barcode</label>
        <input type="text" name="barcode" class="form-control @error('barcode') is-invalid @enderror" id="barcode"
          placeholder="barcode" value="{{ old('barcode') }}">
        @error('barcode')
        <span class="invalid-feedback" role="alert">
          <strong>{{ $message }}</strong>
        </span>
        @enderror
      </div>

      <div class="form-group">
        <label for="price">Harga</label>
        <input type="text" name="price" class="form-control @error('price') is-invalid @enderror" id="price"
          placeholder="Harga" value="{{ old('price') }}">
        @error('price')
        <span class="invalid-feedback" role="alert">
          <strong>{{ $message }}</strong>
        </span>
        @enderror
      </div>

      <div class="form-group">
        <label for="quantity">Jumlah Product</label>
        <input type="text" name="quantity" class="form-control @error('quantity') is-invalid @enderror" id="quantity"
          placeholder="Jumlah Product" value="{{ old('quantity', 1) }}">
        @error('quantity')
        <span class="invalid-feedback" role="alert">
          <strong>{{ $message }}</strong>
        </span>
        @enderror
      </div>

      <div class="form-group">
        <label for="status">Status</label>
        <select name="status" class="form-control @error('status') is-invalid @enderror" id="status">
          <option value="1" {{ old('status')===1 ? 'selected' : '' }}>Active</option>
          <option value="0" {{ old('status')===0 ? 'selected' : '' }}>Inactive</option>
        </select>
        @error('status')
        <span class="invalid-feedback" role="alert">
          <strong>{{ $message }}</strong>
        </span>
        @enderror
      </div>

      <button type="submit" class="btn btn-primary">Tambah</button>
    </form>

  </div>
</div>
@endsection

@push('scripts')
<script src="{{ asset('plugins/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>
<script>
  $(document).ready(function () {
            bsCustomFileInput.init();
        });
</script>
@endpush

resources/views/pages/product/edit.blade.php
@extends('adminlte.master')

@section('title', 'Edit Product')

@section('content')
<div class="card">
  <div class="card-header">
    <h3 class="card-title">Edit product</h3>
  </div>
  <!-- /.card-header -->
  <div class="card-body">
    <form action="{{ route('products.update', $product->id) }}" method="POST" enctype="multipart/form-data">
      @csrf
      @method('PUT')

      <div class="form-group">
        <label for="name">Nama Product</label>
        <input type="text" name="name" class="form-control @error('name') is-invalid @enderror" id="name"
          placeholder="Nama Product" value="{{ old('name', $product->name) }}">
        @error('name')
        <span class="invalid-feedback" role="alert">
          <strong>{{ $message }}</strong>
        </span>
        @enderror
      </div>

      <div class="form-group">
        <label for="description">Deskripsi Product</label>
        <input type="text" name="description" class="form-control @error('description') is-invalid @enderror"
          id="description" placeholder="Deskripsi Product" value="{{ old('description', $product->description) }}">
        @error('description')
        <span class="invalid-feedback" role="alert">
          <strong>{{ $message }}</strong>
        </span>
        @enderror
      </div>

      <div class="form-group">
        <label for="image">Gambar Product</label>
        <div class="custom-file">
          <input type="file" class="custom-file-input" @error('image') is-invalid @enderror name="image" id="image"
            onchange="previewImage()">
          <label class="custom-file-label" for="image">Choose file</label>

          <!-- menampilkan gambar lama -->
          <input type="hidden" name="oldImage" value="{{ $product->image }}">
          @if ($product->image)
          <img src="{{ asset('storage/'. $product->image) }}" class="image-preview img-fluid mt-2 col-sm-3 d-block">
          @else
          <img class="image-preview img-fluid col-sm-3">
          @endif
          <br>
        </div>
        @error('image')
        <span class="invalid-feedback" role="alert">
          <strong>{{ $message }}</strong>
        </span>
        @enderror
      </div>

      <div class="form-group">
        <label for="barcode">Barcode</label>
        <input type="text" name="barcode" class="form-control @error('barcode') is-invalid @enderror" id="barcode"
          placeholder="Barcode" value="{{ old('barcode', $product->barcode) }}">
        @error('barcode')
        <span class="invalid-feedback" role="alert">
          <strong>{{ $message }}</strong>
        </span>
        @enderror
      </div>

      <div class="form-group">
        <label for="price">Harga</label>
        <input type="text" name="price" class="form-control @error('price') is-invalid @enderror" id="price"
          placeholder="Harga" value="{{ old('price', $product->price) }}">
        @error('price')
        <span class="invalid-feedback" role="alert">
          <strong>{{ $message }}</strong>
        </span>
        @enderror
      </div>

      <div class="form-group">
        <label for="address">Jumlah Product</label>
        <input type="text" name="quantity" class="form-control @error('quantity') is-invalid @enderror" id="quantity"
          placeholder="Jumlah Product" value="{{ old('quantity', $product->quantity) }}">
        @error('quantity')
        <span class="invalid-feedback" role="alert">
          <strong>{{ $message }}</strong>
        </span>
        @enderror
      </div>

      <div class="form-group">
        <label for="status">Status</label>
        <select name="status" class="form-control @error('status') is-invalid @enderror" id="status">
          <option value="1" {{ old('status', $product->status) === 1 ? 'selected' : ''}}>Active</option>
          <option value="0" {{ old('status', $product->status) === 0 ? 'selected' : ''}}>Inactive</option>
        </select>
        @error('status')
        <span class="invalid-feedback" role="alert">
          <strong>{{ $message }}</strong>
        </span>
        @enderror
      </div>

      <button type="submit" class="btn btn-primary">Update</button>
    </form>

  </div>
</div>
@endsection

@push('scripts')
<script src="{{ asset('plugins/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>
<script>
  $(document).ready(function () {
            bsCustomFileInput.init();
        });

  function previewImage() {
    const image = document.querySelector('#image');
    const imagePreview = document.querySelector('.image-preview');

    imagePreview.style.display = 'block';

    const oFReader = new FileReader();
    oFReader.readAsDataURL(image.files[0]);

    oFReader.onload = function(oFREvent) {
        imagePreview.src = oFREvent.target.result;
    }
  }
</script>
@endpush

resources/views/pages/product/index.blade.php
@extends('adminlte.master')

@section('title', 'Product')

@push('plugins')
<link rel="stylesheet" href="{{ asset('plugins/sweetalert2/sweetalert2.min.css') }}">
@endpush
@section('content')
<div class="col-12">
  <div class="card">
    <div class="card-header">
      <h3 class="card-title">Product</h3>
      <div class="card-tools">
        <a href="{{ route('products.create') }}" class="btn btn-tool btn-sm">
          <i class="fas fa-plus"></i>
        </a>
      </div>
    </div>

    <!-- /.card-body -->
    <div class="card-body">
      <table id="example1" class="table table-bordered table-striped">
        <thead>
          <tr>
            <th>ID</th>
            <th>Name</th>
            <th>Image</th>
            <th>Barcode</th>
            <th>Price</th>
            <th>Quantity</th>
            <th>Status</th>
            <th>Created At</th>
            <th>Updated At</th>
            <th>Actions</th>
          </tr>
        </thead>
        <tbody>
          @foreach ($products as $item)
          <tr>
            <td>{{ $loop->iteration }}</td>
            <td>{{$item->name}}</td>
            <td>
              <img width="50" src="{{ asset('storage/'. $item->image) }}" alt="{{ $item->name }}">
            </td>
            <td>{{$item->barcode}}</td>
            <td>{{$item->price}}</td>
            <td>{{$item->quantity}}</td>
            <td>
              <span class="right badge badge-{{ $item->status ? 'success' : 'danger' }}">{{$item->status ?
                'Active' : 'Inactive'}}</span>
            </td>
            <td>{{$item->created_at}}</td>
            <td>{{$item->updated_at}}</td>
            <td>
              <a href="{{ route('products.edit', $item->id) }}" class="btn btn-secondary">
                <i class="fas fa-edit"></i>
              </a>
              <a href="{{ route('products.show', $item->id) }}" class="btn btn-secondary">
                <i class="fas fa-eye"></i>
              </a>

              <a class="btn btn-danger btn-delete" data-url="{{route('products.destroy', $item)}}"><i
                  class="fas fa-trash"></i></a>
            </td>
          </tr>
          @endforeach
        </tbody>
      </table>
      {{ $products->render() }}
    </div>
  </div>
</div>
@endsection

@push('scripts')
<script src=" {{ asset('plugins/datatables/jquery.dataTables.min.js') }}"></script>
<script src="{{ asset('plugins/datatables-bs4/js/dataTables.bootstrap4.min.js') }}"></script>
<script src="{{ asset('plugins/datatables-responsive/js/dataTables.responsive.min.js') }}"></script>
<script src="{{ asset('plugins/datatables-responsive/js/responsive.bootstrap4.min.js') }}"></script>
<script src="{{ asset('plugins/datatables-buttons/js/dataTables.buttons.min.js') }}"></script>
<script src="{{ asset('plugins/datatables-buttons/js/buttons.bootstrap4.min.js') }}"></script>
<script src="{{ asset('plugins/jszip/jszip.min.js') }}"></script>
<script src="{{ asset('plugins/pdfmake/pdfmake.min.js') }}"></script>
<script src="{{ asset('plugins/pdfmake/vfs_fonts.js') }}"></script>
<script src="{{ asset('plugins/datatables-buttons/js/buttons.html5.min.js') }}"></script>
<script src="{{ asset('plugins/datatables-buttons/js/buttons.print.min.js') }}"></script>
<script src="{{ asset('plugins/datatables-buttons/js/buttons.colVis.min.js') }}"></script>
<script src="{{ asset('plugins/sweetalert2/sweetalert2.min.js') }}"></script>
<script>
  $(function () {
        $("#example1").DataTable({
        "responsive": true, "lengthChange": false, "autoWidth": false,
        "buttons": ["copy", "csv", "excel", "pdf", "print", "colvis"]
        }).buttons().container().appendTo('#example1_wrapper .col-md-6:eq(0)');
    });

    $(document).ready(function () {
            $(document).on('click', '.btn-delete', function () {
                $this = $(this);
                const swalWithBootstrapButtons = Swal.mixin({
                    customClass: {
                        confirmButton: 'btn btn-success',
                        cancelButton: 'btn btn-danger mr-2'
                    },
                    buttonsStyling: false
                })

                swalWithBootstrapButtons.fire({
                    title: 'Are you sure?',
                    text: "Do you really want to delete this customer?",
                    icon: 'warning',
                    showCancelButton: true,
                    confirmButtonText: 'Yes, delete it!',
                    cancelButtonText: 'No',
                    reverseButtons: true
                }).then((result) => {
                    if (result.value) {
                        $.post($this.data('url'), {_method: 'DELETE', _token: '{{csrf_token()}}'}, function (res) {
                            $this.closest('tr').fadeOut(500, function () {
                                $(this).remove();
                            })
                        })
                    }
                })
            })
        })
</script>

@endpush

resources/views/pages/product/show.blade.php
@extends('adminlte.master')

@section('title', 'Halaman Produk')

@section('content')
<div class="col-12">
  <div class="card">
    <div class="card-header">
      <h3 class="card-title">Tampilkan Produk</h3>
      <div class="card-tools">
        <a href="/products" class="btn btn-tool btn-sm btn-success">
          <i class="fas fa-arrow-left"></i>
        </a>
      </div>
    </div>
    <!-- /.card-header -->
    <div class="card-body">
      <strong><i class=""></i> Nama Produk</strong>
      <p class="text-muted">
        {{ $product->name }}
      </p>
      <hr>
      <strong><i class=""></i> Deskripsi Produk</strong>
      <p class="text-muted">
        {{ $product->description }}
      </p>
      <hr>
      <strong><i class=""></i> Foto Produk</strong>
      <p class="text-muted">
        <img src="{{ asset('storage/' . $product->image) }}" alt="{{ $product->name }}" class="img-fluid" width="200px"
          height="auto">
      </p>
      <hr>
      <strong><i class=""></i> Barcode</strong>
      <p class="text-muted">
        {{ $product->barcode }}
      </p>
      <hr>
      <strong><i class=""></i> Harga Produk</strong>
      <p class="text-muted">
        {{ $product->price }}
      </p>
      <hr>
      <strong><i class=""></i> Jumlah Produk</strong>
      <p class="text-muted">
        {{ $product->quantity }}
      </p>
      <hr>
    </div>
  </div>
</div>
@endsection